//G36C.cs
//Model by Pandan. Script by Amade.

//audio
datablock AudioProfile(G36CshotSound)
{
   filename    = "Add-Ons/Weapon_Gun/gunShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(G36ChitSound)
{
   filename    = "Add-Ons/Weapon_Gun/bulletHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DebrisData(G36CshellDebris)
{
   shapeFile    = "Add-Ons/Weapon_Gun/gunshell.dts";
   lifetime     = 2;
   minSpinSpeed = -200.0;
   maxSpinSpeed = 200.0;
   elasticity = 0.6;
   friction = 0.1;
   numBounces = 3;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;

   gravModifier = 2;
};

datablock ParticleData(G36CflashParticle)
{
   dragCoefficient      = 1;
   gravityCoefficient   = -2;
   inheritedVelFactor   = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS           = 150;
   lifetimeVarianceMS   = 50;
   textureName          = "base/data/particles/cloud";
   spinSpeed = 10.0;
   spinRandomMin = -500.0;
   spinRandomMax = 500.0;
   colors[0] = "1 1 0.0 0.5";
   colors[1] = "1 0 0 0.1";
   sizes[0] = 0.15;
   sizes[1] = 0.5;

   useInvAlpha = false;
};

datablock ParticleEmitterData(G36CflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 30;
   thetaMax         = 45;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "G36CflashParticle";
};

datablock ParticleData(G36CsmokeParticle)
{
   dragCoefficient      = 1;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 50;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin      = -500.0;
   spinRandomMax      = 500.0;
   colors[0]     = "0.5 0.5 0.5 0.5";
   colors[1]     = "0.5 0.5 0.5 0";
   sizes[0]      = 0.225;
   sizes[1]      = 0.125;

   useInvAlpha = false;
};
datablock ParticleEmitterData(G36CsmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1.25;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 25;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "G36CsmokeParticle";
};

datablock ParticleData(G36CexplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 400;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin      = -50.0;
   spinRandomMax      = 50.0;
   colors[0]     = "0.9 0.9 0.9 0.3";
   colors[1]     = "0.9 0.5 0.6 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.75;

   useInvAlpha = true;
};
datablock ParticleEmitterData(G36CexplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "G36CexplosionParticle";
};

datablock ParticleData(G36CexplosionRingParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 0;
   inheritedVelFactor   = -0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 50;
   lifetimeVarianceMS   = 35;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 200;
   spinRandomMin      = -100;
   spinRandomMax      = 100;
   colors[0]     = "1 1 0.0 0.9";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 1;
   sizes[1]      = 0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(G36CexplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0.3;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "G36CexplosionRingParticle";
};

datablock ExplosionData(G36Cexplosion)
{
   //explosionShape = "";
   soundProfile = G36ChitSound;

   lifeTimeMS = 150;

   particleEmitter = G36CexplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = G36CexplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "1 0.75 0.25";
   lightEndColor = "0 0 0";
};


AddDamageType("G36C",'<bitmap:add-ons/Weapon_G36C/CI_G36C> %1','%2 <bitmap:add-ons/Weapon_G36C/CI_G36C> %1',0.5,1);

datablock ProjectileData(G36Cprojectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::G36C;
   radiusDamageType    = $DamageType::G36C;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3; 
   brickExplosionMaxVolumeFloating = 5;

   impactImpulse   = 5;
   verticalImpulse = 15;
   explosion       = G36Cexplosion;

   muzzleVelocity   = 140;
   velInheritFactor = 1;

   armingDelay      = 0;
   lifetime         = 4000;
   fadeDelay        = 3500;

   bounceElasticity = 0.01;
   bounceFriction   = 0.99;

   isBallistic      = false;
   gravityMod       = 0;

   hasLight    = false;

   uiName = "G36C Bullet";
};

datablock ItemData(G36Citem)
{
   category = "Weapon";
   className = "Weapon";

   shapeFile = "./G36C.dts";
   rotate = false;
   mass = 2;
   density = 1;
   elasticity = 0.1;
   friction = 0.9;
   emap = true;

   uiName = "G36C";
   iconName = "./icon_G36C";
   doColorShift = false;
   colorShiftColor = "0.25 0.25 0.25 1";

   image = G36Cimage;
   canDrop = true;
};

datablock ShapeBaseImageData(G36Cimage)
{
   shapeFile = "./G36C.dts";
   emap      = true;

   mountPoint = 0;
   offset     = "0 0 0";
   eyeOffset  = 0;
   rotation   = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = G36Citem;
   ammo = " ";

   projectile     = G36Cprojectile;
   projectileType = Projectile;

   casing = G36CshellDebris;
   shellExitDir        = "1.0 -1.3 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;   
   shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = G36Citem.colorShiftColor;

   stateName[0]                    = "Activate";
   stateTransitionOnTriggerDown[0] = "Fire";
   stateSound[0]                   = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateEmitter[1]                 = G36CsmokeEmitter;
   stateEmitterTime[1]             = 1;
   stateEmitterNode[1]             = "muzzleNode";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1]        = true;
   stateSequence[1]                = "Ready";

   stateName[2]                = "Fire";
   stateTransitionOnTimeout[2] = "Smoke";
   stateTimeoutValue[2]        = 0.04;
   stateFire[2]                = true;
   stateAllowImageChange[2]    = false;
   stateSequence[2]            = "Fire";
   stateScript[2]              = "onFire";
   stateWaitForTimeout[2]      = true;
   stateEmitter[2]             = G36CflashEmitter;
   stateEmitterTime[2]         = 0.04;
   stateEmitterNode[2]         = "muzzleNode";
   stateSound[2]               = G36CshotSound;
   stateEjectShell[2]          = true;

   stateName[3]                = "Smoke";
   stateTimeoutValue[3]        = 0.04;
   stateTransitionOnTimeout[3] = "Reload";

   stateName[4]                    = "Reload";
   stateSequence[4]                = "Reload";
   stateTransitionOnTriggerUp[4]   = "Ready";
   stateTransitionOnTriggerDown[4] = "Fire";
   stateSequence[4]                = "Ready";
};

//Thanks to Ephialtes for this part. It makes the bullets spread out.
function G36CImage::onFire(%this,%obj,%slot)
{     
   %projectile = %this.projectile;
   %spread = 0.00175;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
}

//Thanks to Destiny for this part. It shoots a grenade on right click, with a 30-second cooldown.
package G36C
{
   function Armor::onTrigger(%this, %player, %slot, %val)
   {
      if(%player.getMountedImage(0) $= G36CImage.getID() && %slot $= 4 && %val)
      {
         if(%player.lastGrenade !$= "" && getSimTime() - %player.lastGrenade < 30000)
         {
            return;
         }
         %projectile = GlrenadeProjectile;
         %vector = %player.getMuzzleVector(0);
         %objectVelocity = %player.getVelocity();
         %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
         %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
         %velocity = VectorAdd(%vector1,%vector2);
         %p = new Projectile()
         {
            dataBlock = %projectile;
            initialVelocity = %velocity;
            initialPosition = %player.getMuzzlePoint(0);
            sourceObject = %player;
            sourceSlot = 0;
            client = %player.client;
         };
         %player.lastGrenade = getSimTime();
         serverPlay3D(rocketFireSound,%player.getPosition());
         MissionCleanup.add(%p);
         return %p;
      }
      Parent::onTrigger(%this, %player, %slot, %val);
   }
};   
ActivatePackage(G36C);